#
# Conditional build:
%bcond_without	tests		# build without tests

Summary:	mold: A Modern Linker
Name:		mold
Version:	1.7.1
Release:	1
License:	GPL v3+
Group:		Development/Libraries
Source0:	https://github.com/rui314/mold/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	112e183443097e91576b6cc7d5226328
URL:		https://github.com/rui314/mold
BuildRequires:	cmake >= 3.13
%{?with_tests:BuildRequires:	glibc-static}
%ifarch %{armv6} riscv64
BuildRequires:	libatomic-devel
%endif
BuildRequires:	libstdc++-devel >= 6:10
%{?with_tests:BuildRequires:	libstdc++-static >= 6:10}
BuildRequires:	mimalloc-devel >= 1.7
BuildRequires:	openssl-devel
BuildRequires:	rpmbuild(macros) >= 2.007
BuildRequires:	tbb-devel >= 2021.3.0
BuildRequires:	zlib-devel
BuildRequires:	zstd-devel
Requires:	mimalloc >= 1.7
Requires:	tbb >= 2021.3.0
ExclusiveArch:	%{ix86} %{x8664} %{arm} aarch64 m68k ppc64 ppc64le riscv32 riscv64 s390x sparc64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
mold is a faster drop-in replacement for existing Unix linkers. It is
several times faster than LLVM lld linker, the second-fastest
open-source linker which I originally created a few years ago. mold is
created for increasing developer productivity by reducing build time
especially in rapid debug-edit-rebuild cycles.

%prep
%setup -q

%{__rm} -r third-party/{mimalloc,tbb}

%build
%cmake -B build \
	%{cmake_on_off tests BUILD_TESTING} \
	-DMOLD_USE_MIMALLOC:BOOL=ON \
	-DMOLD_USE_SYSTEM_MIMALLOC:BOOL=ON \
	-DMOLD_USE_SYSTEM_TBB:BOOL=ON

%{__make} -C build

%if %{with tests}
%{__make} -C build test
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CONTRIBUTING.md README.md docs/*.md
%attr(755,root,root) %{_bindir}/ld.mold
%attr(755,root,root) %{_bindir}/ld64.mold
%attr(755,root,root) %{_bindir}/mold
%dir %{_libdir}/mold
%attr(755,root,root) %{_libdir}/mold/mold-wrapper.so
%dir %{_libexecdir}/mold
%attr(755,root,root) %{_libexecdir}/mold/ld
%{_mandir}/man1/mold.1*
%{_mandir}/man1/ld.mold.1*
%changelog
* Fri Nov 18 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mold.git;a=log;h=master

* Fri Nov 18 2022 Jan Palus <atler@pld-linux.org> bb347c5
- up to 1.7.1

* Sun Nov 13 2022 Jan Palus <atler@pld-linux.org> 7aad5a4
- more supported archs

* Sun Nov 13 2022 Jan Palus <atler@pld-linux.org> 5ef7b19
- up to 1.7.0

* Wed Oct 19 2022 Jan Palus <atler@pld-linux.org> e26d185
- upstream fixes for x86 32bit non-PIC failures; rel 2

* Wed Oct 19 2022 Jan Palus <atler@pld-linux.org> ddd5c32
- up to 1.6.0

* Thu Sep 29 2022 Jan Palus <atler@pld-linux.org> 309afd1
- up to 1.5.1

* Wed Sep 28 2022 Jan Palus <atler@pld-linux.org> ffeb613
- up to 1.5.0

* Sun Sep 04 2022 Jan Palus <atler@pld-linux.org> 8668a43
- up to 1.4.2

* Sat Aug 20 2022 Jan Palus <atler@pld-linux.org> ccc1822
- upstream fix for crash on %{arm} when throwing cpp exception

* Thu Aug 18 2022 Jan Palus <atler@pld-linux.org> a32f40a
- up to 1.4.1

* Wed Aug 17 2022 Jan Palus <atler@pld-linux.org> 15000b4
- Release 2 (by relup.sh)

* Fri Aug 05 2022 Jan Palus <atler@pld-linux.org> c2be346
- up to 1.4.0

* Fri Jul 01 2022 Jan Palus <atler@pld-linux.org> edb3d1a
- up to 1.3.1

* Wed Jun 29 2022 Jan Palus <atler@pld-linux.org> b5cd69c
- add tests invocation

* Wed Jun 29 2022 Jan Palus <atler@pld-linux.org> 69539fe
- upstream fix for arm32

* Sat Jun 18 2022 Jan Palus <atler@pld-linux.org> 0a2ebcd
- up to 1.3.0

* Thu Apr 28 2022 Jan Palus <atler@pld-linux.org> 748b4f8
- up to 1.2.1

* Mon Apr 18 2022 Jan Palus <atler@pld-linux.org> 4f192f3
- link with libatomic on %{armv6}

* Mon Apr 18 2022 Jan Palus <atler@pld-linux.org> a163719
- up to 1.2.0

* Mon Apr 18 2022 Jan Palus <atler@pld-linux.org> ab41b3b
- add EA:

